#include <windows.h>
#include <setupapi.h>

static GUID GUID_DEVINTERFACE_USB_DEVICE =
{ 0xA5DCBF10L, 0x6530, 0x11D2, { 0x90, 0x1F, 0x00, 0xC0, 0x4F, 0xB9, 0x51, 0xED } };

int main()
{
    int length;
    char msgbuff[200];
    HDEVINFO devInfoSet;
    SP_DEVICE_INTERFACE_DATA devInterfaceData;
    PSP_DEVICE_INTERFACE_DETAIL_DATA pDevInterfaceDetailData;

    devInterfaceData.cbSize = sizeof(SP_DEVICE_INTERFACE_DATA);

    devInfoSet = SetupDiGetClassDevs( &GUID_DEVINTERFACE_USB_DEVICE,
                                                     NULL,
                                                     NULL,
                                                     DIGCF_PRESENT | DIGCF_DEVICEINTERFACE );

    printf( "rv SetupDiGetClassDevs = %d\n\n", devInfoSet );

    printf( "rv SetupDiEnumDeviceInterfaces = %d\n\n",
              SetupDiEnumDeviceInterfaces( devInfoSet,
                                                        NULL,
                                                        &GUID_DEVINTERFACE_USB_DEVICE,
                                                        0,
                                                        &devInterfaceData) );

    // Call SetupDiGetDeviceInterfaceDetail with the DeviceInterfaceDetailData
    // paramater set to NULL and the DeviceInterfaceDetailDataSize parameter
    // set to zero, so the function will return the required buffer size in
    // the RequiredSize parameter.

    printf( "rv SetupDiGetDeviceInterfaceDetail = %d\n\n",
              SetupDiGetDeviceInterfaceDetail( devInfoSet,
                                                            &devInterfaceData,
                                                            NULL,
                                                            0,
                                                            &length,
                                                            NULL ) );

    FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM,
                           0,
                           GetLastError(),
                           0,
                           (LPSTR) &msgbuff,
                           200,
                           0 );

    printf( "%s\n", &msgbuff );

    printf( "required buffer length = %d\n\n", length );

    // Allocate a buffer of the required length.

    pDevInterfaceDetailData = (PSP_DEVICE_INTERFACE_DETAIL_DATA) malloc( length );

    printf( "rv malloc = %d\n\n", pDevInterfaceDetailData );

    printf( "sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA) = %d\n\n",
              sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA) );

    // Set the first dword to the value 5.

    pDevInterfaceDetailData->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);

    // Call SetupDiGetDeviceInterfaceDetail again with
    // all of the necessary parameters.

    printf( "rv SetupDiGetDeviceInterfaceDetail = %d\n\n",
              SetupDiGetDeviceInterfaceDetail( devInfoSet,
                                                            &devInterfaceData,
                                                            pDevInterfaceDetailData,
                                                            length,
                                                            &length,
                                                            NULL ) );

    printf( "rv SetupDiDestroyDeviceInfoList = %d\n\n",
              SetupDiDestroyDeviceInfoList( devInfoSet ) );

    free( pDevInterfaceDetailData );

    while( !kbhit() );
    return 0;
}